Subject: Re: [PATCH] patch series: Update Raku ecosystem

From: "Daniel Sockwell" <[email-masked]>
Date: Thu, 08 Sep 2022 02:18:00 +0000

Thanks so much for the feedback. I've answered a few questions inline 
below and I'll follow up with revised patches in the next few days.

September 7, 2022 5:56 PM, "Maxime Devos" <[email-masked]> wrote:
> IIUC, this means that previously, it didn't include a copy [of the 
> Unicode Character Database], and now it does?

No, it did previously as well; the description just didn't mention it

> (If this was already the case in the previous version, that's still bad,
> but then it can be left for later, being independent of this patch.)

Understood.  I'll put that on the to-do list for future patches (though 
pinning specific versions of MoarVM/Rakudo to specific versions of the UCD
is important, so unbundling might mean including more up-to-date versions
of the UCD, unless Guix already stays very current there).

> I noticed you removed the mention of the garbage collector, is this 
> intentional? 

I cut the GC from the list of features in an effort to stay within Guix's 
length guidelines for descriptions (and because having a GC doesn't do much
to distinguish Raku from Perl/Python/nearly all Lisps/JS, etc.)  But the GC
is very much still present :)

> On nqp-configure: Are you sure that 'bin' should be installed in '.../bin'? 
> Looking at the Git repository, make.nqp does not have a shebang and can hence
> not be directly run, maybe you should add a shebang?
> 
> Also, is there appear to be some tests in 't', why aren't they run? There is a
> 'rakudo-build-system', maybe this rakudo-build-system can properly build this 
> package 

I'll double check the above.

> On nqp: why the switch from downloading the source code from the apparent official site
> "rakudo.perl6.org" to GitHub?

The Rakudo site no longer hosts NQP, just Rakudo.  See https://rakudo.perl6.org/downloads

>> + (substitute* "t/09-moar/01-profilers.t"
>> + (("ok.*\\$htmlpath" html-test-text)
>> + (string-append "todo \"harness5 fails to write html profile\";"
>> + html-test-text)))))
> 
> What's the issue here? Is it a limitation of the Guix packaging, or could it perhaps
> be an upstream bug? If the latter, upstream needs to be informed such that they can 
> fix the bug.

I'm honestly unsure.  I can't understand why it would be a Guix-specific issue, but I've
also never had that test fail when building from source on other distros.  More investigation
is called for.

> On the new package description: ... It's getting close to marketing phrases

Thanks.  I could tell I was getting a bit close to that line and guess I let my enthusiasm 
carry me away a bit; I'll rein it in.

> Can you verify that our various perl6-... libraries still build, and that when doing, say, 
> "guix shell rakudo perl6-json-name -- whatever-rakudos-binary-name-is", you can still use
> perl6-json-name in whatever is rakudo's name for a REPL?

Will do.  (Everything *should* be backwards compatible, but it's 100% worth checking)

> You add some patches, but they need to be registered in gnu/local.mk as well, please do so.

Will do.

> On the patch file name: it looks a little suspect, perhaps if you run the linter on the 
> packages it will have a comment about the file names.

I ran the linter and its only comment was that patches need to start with the package name.
Is there another rule?

> On commit messages: they don't follow our conventions. ... A new copyright line can also be added.

Will fix.
 
> Greetings,

Thanks!  I'm glad to be able to help with a small corner of Guix :)